use std::fs::File;
use std::io::prelude::*;
use std::io;
use std::io::{Read, Write};


fn bad_indexing(index: usize) -> u64 {
    let v: Vec<u64> = vec![3, 20, 54];
    return v[index];
}

fn good_indexing(index: usize) -> u64 {
    let v: Vec<u64> = vec![3, 20, 54];
    match v.get(index) {
        Some(value) => *value,
        None => 0,
    }
}


fn open_file(filename: &str) -> Result<File, io::Error> {
    return File::open(filename);
}


fn main() {
    //bad_indexing(99);
    //good_indexing(99);
    

    match open_file("./examples/example.txt") {
        Ok(mut file) => {
            let mut s = String::new();
            file.read_to_string(&mut s);
            println!("{:?}", s);
        },
        Err(error) => {
            println!("Error: {:?}", error);
            let mut f = File::create("./examples/example.txt").unwrap();
            f.write_all(b"Hello world!\nThis is an error handling example.\n").unwrap();
        },
    };

/*
   
1. The bad state is not something that’s expected to happen occasionally.
2. Your code after this point needs to rely on not being in this bad state.
3. There’s not a good way to encode this information in the types you use.

*/
}