mod book;
use book::Book;

/*

1. Each value in Rust has a variable that’s called its owner.
2. There can only be one owner at a time.
3. When the owner goes out of scope, the value will be dropped.

 */


fn stuff(book: &mut Book) {
    println!("{:?}", book);
}


fn main() {
    let mut book = Book::new(String::from("Honey Potter"));
    stuff(&mut book);

    {
        let book2 = &book;
        println!("{:?}", book2);
    }

    println!("{:?}", book);
}